accounts/urls.py
from django.urls import path
from .views import register
from django.contrib.auth import views as auth_views

app_name = "accounts"

urlpatterns = [
    # path('login/', login, name="login"),
    path('login/', auth_views.LoginView.as_view(
        template_name="accounts/login.html", redirect_authenticated_user=True),
        name="login"),
    path('register/', register, name="register"),
    path('logout/', auth_views.LogoutView.as_view(
        template_name="accounts/logout.html"), name='logout'),
    # path('', dummy, name="dummy"),
]

competition_master/urls.py
from django.contrib import admin
from django.urls import path, include
# from home.views import landingpage
from django.conf.urls import url

urlpatterns = [
    path('', include('home.urls')),
    path('accounts/', include('accounts.urls', namespace="accounts")),
    path('games/', include('game.urls', namespace="games")),
    path('quiz/', include('quiz.urls', namespace="quiz")),
    # path('accounts/', include('django.contrib.auth.urls')),
    path('admin/', admin.site.urls),
    url(r'^oauth/', include('social_django.urls', namespace='social')),
]

game/urls.py
from django.urls import path
from .views import Games, GameDetailView

app_name = "games"

urlpatterns = [
    path('', Games.as_view(), name="games_list"),
    path('<str:slug>/', GameDetailView.as_view(), name="game_detail"),
]

home/urls.py
from django.urls import path
from .views import landingpage, dashboard

app_name = "home"

urlpatterns = [
    path('', landingpage, name="index"),
    path('dashboard/', dashboard, name="dashboard"),
    path('test/', landingpage, name="test"),
]

home/models.py
from django.db import models

# Create your models here.

home/views.py
from django.shortcuts import render, redirect
# from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required
from game.models import GameScore
from quiz.models import QuizScore
from django.db.models.aggregates import Max


@login_required
def landingpage(request):
    # print(request.META.get('HTTP_REFERER'))

    # Other values that you can find in the values_list include:
    # id, uid (for ex. facebook user id), user, extra_data
    # (which contains the access_token)
    # print(request.user.social_auth.values_list('provider'))

    # print(request.user.social_auth.values_list('provider')[0][0])
    # if not request.user.is_anonymous and \
    # if request.user.social_auth.filter(user=request.user).count() > 0:
    #     provider = request.user.social_auth.values_list('provider')[0][0]
    #     user_exists = User.objects.filter(username=request.user.username)

    #     if 'google' in provider:
    #         provider = "google"

    #     if user_exists.count() > 0:
    #         social_user = User.objects.filter(username=request.user.username)

    #         social_user.update(username=request.user.username+"_"+provider)
            # social_user.update(username=request.user.social_auth.values_list
            #                    ('extra_data')[0][0]["login"]+"_"+provider)

        # print("<Social>" + request.user.social_auth.values_list
        #       ('extra_data')[0][0]["login"])

    # else:
    #     print("<Local> "+request.user.username)
    if request.user.is_superuser:
        return redirect('admin:index')
    else:
        return render(request, "index.html")


@login_required
def dashboard(request):
    # return HttpResponse("Hello")
    if request.user.is_superuser:
        return redirect('admin:index')
    else:
        # get top scorers
        game_ids = []
        game_model = GameScore.objects.all().order_by("-score")
        game_top_scorers = {}
        for item in game_model:
            if len(game_top_scorers) == 3:
                break

            if item.game_id not in game_ids:
                game_ids.append(item.game_id)
                game_top_scorers[item.game] = {"user": item.user.username,
                                               "score": item.score}
        topic_ids = []
        quiz_model = QuizScore.objects.all().order_by("-score")
        quiz_top_scorers = {}
        for item in quiz_model:
            if len(quiz_top_scorers) == 3:
                break
            if item.topic_id not in topic_ids:
                topic_ids.append(item.topic_id)
                quiz_top_scorers[item.topic] = {"user": item.user.username,
                                                "score": item.score}

        # print(game_top_scorers)
        # print(quiz_top_scorers)
        top_score_context = {
            "games": game_top_scorers, "quiz": quiz_top_scorers}
        return render(request, "dashboard.html", top_score_context)


# def login(request):
#     return render(request, "login.html")

home/templates/base.html
<!doctype html> {%load staticfiles%}
<html lang="en">

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"> -->
    <script src="https://code.jquery.com/jquery-3.4.1.js"></script>
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

    <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet"> 
    <link href="{% static 'home/base.css' %}" rel="stylesheet"> 
    {% block css-content%} {% endblock %} {% block js-content%} {% endblock %}
    <script src="https://code.jquery.com/jquery-3.4.1.js"></script>
    <title>Let's compete!</title>
</head>

<body>
    <!--Navbar -->
    <nav class="navbar navbar-expand-md navbar-dark bg-dark navbar-static-top sticky-top">
        <a class="navbar-brand" href="{% url 'home:index' %}">Competition Master</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent-333" aria-controls="navbarSupportedContent-333" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarSupportedContent-333">
            <!-- <ul class="navbar-nav mr-auto">
                <li class="nav-item active">
                    <a class="nav-link" href="#">Home
                        <span class="sr-only">(current)</span>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#">Features</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#">Pricing</a>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" id="navbarDropdownMenuLink-333" data-toggle="dropdown"
                        aria-haspopup="true" aria-expanded="false">Dropdown
                    </a>
                    <div class="dropdown-menu dropdown-default" aria-labelledby="navbarDropdownMenuLink-333">
                        <a class="dropdown-item" href="#">Action</a>
                        <a class="dropdown-item" href="#">Another action</a>
                        <a class="dropdown-item" href="#">Something else here</a>
                    </div>
                </li>
            </ul> -->

            <ul class="navbar-nav ml-auto nav-flex-icons">
                {% if user.is_authenticated %}
                <!-- <li class="nav-item">
                    <a class="nav-link waves-effect waves-light">
                        <i class="fa fa-twitter"></i>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link waves-effect waves-light">
                        <i class="fa fa-google-plus"></i>
                    </a>
                </li> -->
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" id="navbarDropdownMenuLink-333" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fa fa-user"></i>
                    </a>
                    <div class="dropdown-menu dropdown-menu-right dropdown-default" aria-labelledby="navbarDropdownMenuLink-333">
                        <a class="dropdown-item username_link" href="#">{{request.user.username}}</a>
                        <a class="dropdown-item text-primary" href="{% url 'home:dashboard' %}">Dashboard</a>
                        <a class="dropdown-item text-primary" href="{% url 'accounts:logout' %}">Logout</a>
                        <!-- <a class="dropdown-item" href="#">Another action</a>
                        <a class="dropdown-item" href="#">Something else here</a> -->
                    </div>
                </li>
                {% else %}
                <li><a href="{% url 'accounts:login' %}" class="nav">Login</a></li>
                {% endif %}
            </ul>

        </div>
    </nav>
    <!--/.Navbar -->

    {% if messages %} {% for message in messages %} {% if 'success' in message.tags %}
    <div class="alert alert-success text-center">
        <strong>{{ message|escape }}</strong>
    </div>
    {% endif %} {% endfor %} {% endif %} {% if form.errors %} {% for field in form %} {% for error in field.errors %}
    <div class="alert alert-danger text-center">
        <strong>{{ error|escape }}</strong>
    </div>
    {% endfor %} {% endfor %} {% for error in form.non_field_errors %}
    <div class="alert alert-danger text-center">
        <strong>{{ error|escape }}</strong>
    </div>
    {% endfor %} {% endif %} {% block content%} {% endblock %}

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <!-- <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script> -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
</body>

</html>

home/templates/dashboard.html
{% extends "base.html"%}
{% load staticfiles %}
{% block css-content%}
<link href="{% static 'home/dashboard.css' %}" rel="stylesheet">
{% endblock %}
{% block content%}
<nav aria-label="breadcrumb" class="position-fixed">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="{% url 'home:index' %}">Home</a></li>
        <li class="breadcrumb-item active">Dashboard</li>
    </ol>
</nav>
<br>
<div class="mt-3 ml-3">
    <h1>Welcome, {{request.user.username}}</h1>
</div>
<div class="split">
    <div class="left gamer">
        <div class="centered">
            {% if games|length > 0 %}
            <h1>Top scoring games</h1>
            <ul class="list-unstyled">
                {% for key, values in games.items %}
                <li>{{key}} - {{values.score}}
                    {% if values.user == request.user.username%}
                    <strong>(scored by You)</strong>
                    {% else %}
                    <strong>(scored by {{values.user}})</strong>
                    {% endif %}
                </li>
                {% endfor %}
            </ul>
            {% else %}
            <h1>No games played yet</h1>
            {% endif %}
        </div>
    </div>

    <div class="right geek">
        <div class="centered">
            {% if quiz|length > 0 %}
            <h1>Top scoring quizes</h1>
            <ul class="list-unstyled">
                {% for key, values in quiz.items %}
                <li>{{key}} - {{values.score}}
                    {% if values.user == request.user.username%}
                    <strong>(scored by You)</strong>
                    {% else %}
                    <strong>(scored by {{values.user}})</strong>
                    {% endif %}
                </li>
                {% endfor %}
            </ul>
            {% else %}
            <h1>No quiz played yet</h1>
            {% endif %}
        </div>
    </div>
</div>
{% endblock%}

home/templates/index.html
{% extends "base.html"%} {% load staticfiles %} {% block css-content%}
<link href="{% static 'home/index.css' %}" rel="stylesheet"> {% endblock %} {% block js-content%}

<script src="{% static 'home/index.js' %}"></script>
{% endblock %} {% block content%}
<div class="split">
    <div class="left gamer">
        <div class="centered">
            <h2>Are you a Gamer?</h2>
        </div>
    </div>

    <div class="right geek">
        <div class="centered">
            <h2>Are you a Geek?</h2>
        </div>
    </div>
</div>
{% endblock%}